/*
  Buzzer
    @omzn  2020/10/20
*/

#include <stdbool.h>
#include <stdint.h>
#include <math.h>
#include "inc/hw_i2c.h"
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "inc/hw_qei.h"
#include "inc/hw_timer.h"
#include "driverlib/rom.h"
#include "driverlib/gpio.h"
#include "driverlib/i2c.h"
#include "driverlib/systick.h"
#include "driverlib/interrupt.h"
#include "driverlib/pin_map.h"
#include "driverlib/sysctl.h"
#include "driverlib/uart.h"
#include "driverlib/pwm.h"
#include "driverlib/timer.h"

#include "driverlib/qei.h"
#include "utils/uartstdio.h"
#include "utils/uartstdio.c" //strong-arm method

#include "periphConf.h" //generated by PinMux

#include "my_util.h"

#include "buzzer.h"

//*****************************************************************************
// Global variables
//*****************************************************************************

//*****************************************************************************
//
// This function sets up UART0 to be used for a console to display information
// as the example is running.
//
//*****************************************************************************
void initConsole(void)
{
  // Enable GPIO port A which is used for UART0 pins.
  SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
  // Configure the pin muxing for UART0 functions on port A0 and A1.
  // This step is not necessary if your part does not support pin muxing.
  GPIOPinConfigure(GPIO_PA0_U0RX);
  GPIOPinConfigure(GPIO_PA1_U0TX);
  // Enable UART0 so that we can configure the clock.
  SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);
  // Use the internal 16MHz oscillator as the UART clock source.
  UARTClockSourceSet(UART0_BASE, UART_CLOCK_PIOSC);
  // Select the alternate (UART) function for these pins.
  GPIOPinTypeUART(GPIO_PORTA_BASE, GPIO_PIN_0 | GPIO_PIN_1);
  // Initialize the UART for console I/O.
  UARTStdioConfig(0, 9600, 16000000);
}

void initInterruptPins(void)
{
  clearSW1PinInt();
  GPIOIntRegister(GPIO_PORTF_BASE, SW1PinIntHandler);
  GPIOIntTypeSet(GPIO_PORTF_BASE, INT_ALL_BUTTONS, GPIO_FALLING_EDGE);
}

//*****************************************************************************
// Event handers
//*****************************************************************************

void SysTickIntHandler(void)
{
  static uint32_t led_color = LED_ALL;
  static uint32_t tick_count = 0;
  if (tick_count % 16 == 0)
  {
    led_color = ~led_color;
    tick_count = 0;
    /*
		 * Note that the 2nd param of GPIOPinWrite denotes pins to be written in bit pattern.
		 * The 3rd param of denotes values to be written in bit pattern.
		 * What really written to GPIO pins is a logical AND of 2nd and 3rd params.
		 */
    GPIOPinWrite(GPIO_PORTF_BASE, LED_RED, led_color);
  }
  tick_count++;
}

void SW1PinIntHandler(void)
{
  disableSW1PinInt();
  
  if (GPIOReadPin(GPIO_PORTF_BASE, INT_LEFT_BUTTON) == 0) {
    clearSW1PinInt();
    enableSW1PinInt();
    return;
  }
  delay_ms(100);
  clearSW1PinInt();
  // do something
  static beep_state = 0;
  static tone_counter = 0;
  int tone = O4C;
  // buzzer is beep -> stop buzzer
  // counter is 0 and not beep -> tone = 04C toneBuzzer(tone)
  //         is 1 and not beep -> tone = 04D toneBuzzer(tone)
  // ...
  if (beep_state == 1) {
    restBuzzer();
    beep_state = 0;
    return;
  }
  if (tone_counter > 5) {
    tone_counter = 0;
  }
  swich(tone_counter % 5) {
    case 0:
      tone = O4C; // ド
      break;
    case 1:
      tone = O4D; // レ
      break;
    case 2:
      tone = O4E; // ミ
      break;
    case 3:
      tone = O4F; // ファ
      break;
    case 4:
      tone = O4G; // ソ
      break;
    default:
      break;
  }
  toneBuzzer(tone);
  beep_state = 1;
  enableSW1PinInt();
}

int main(void)
{
  // Set the clocking to run directly from the crystal.
  ROM_SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                     SYSCTL_XTAL_16MHZ);
  // Set up ports hardware (see periphConf.c)
  PortFunctionInit();

  // Set up interrupts (you can specify GPIO interrupt initialization here)
  initInterruptPins();

  // Initialize console
  initConsole();
  UARTprintf("Buzzer!\n");

  initBuzzer();

  enableSW1PinInt();
  restBuzzer();
  // toneBuzzer(O4C);
  // PWMGenPeriodSet(PWM0_BASE, PWM_GEN_1, O4C);
  // PWMPulseWidthSet(PWM0_BASE, PWM_OUT_3, O4C >> 1);
  // PWMOutputState(PWM0_BASE, PWM_OUT_3_BIT, true);
  // delay_ms(1000);
  // restBuzzer();
  // PWMOutputState(PWM0_BASE, PWM_OUT_3_BIT, false);

  // SysTickPeriodSet(SysCtlClockGet() / SYSTICKS_PER_SEC);
  // SysTickEnable();
  // SysTickIntRegister(SysTickIntHandler);
  // SysTickIntEnable();

  while (1)
    ;
}
